aboutsummaryrefslogtreecommitdiffstats
path: root/tests
diff options
context:
space:
mode:
authorBrian Behlendorf <[email protected]>2018-03-28 10:19:22 -0700
committerGitHub <[email protected]>2018-03-28 10:19:22 -0700
commitb2ab468dded24a090dba9fc8396b3d394011ce14 (patch)
tree52ce015e474ee028851256f3b423075b7cf73f58 /tests
parent668173b5764386b47de0beb7c57ff8ce8f68f983 (diff)
Fix mmap / libaio deadlock
Calling uiomove() in mappedread() under the page lock can result in a deadlock if the user space page needs to be faulted in. Resolve the issue by dropping the page lock before the uiomove(). The inode range lock protects against concurrent updates via zfs_read() and zfs_write(). Reviewed-by: Albert Lee <[email protected]> Reviewed-by: Chunwei Chen <[email protected]> Signed-off-by: Brian Behlendorf <[email protected]> Closes #7335 Closes #7339
Diffstat (limited to 'tests')
-rw-r--r--tests/runfiles/linux.run2
-rw-r--r--tests/zfs-tests/cmd/Makefile.am1
-rw-r--r--tests/zfs-tests/cmd/mmap_libaio/.gitignore1
-rw-r--r--tests/zfs-tests/cmd/mmap_libaio/Makefile.am9
-rw-r--r--tests/zfs-tests/cmd/mmap_libaio/mmap_libaio.c88
-rw-r--r--tests/zfs-tests/include/commands.cfg1
-rw-r--r--tests/zfs-tests/tests/functional/mmap/Makefile.am3
-rwxr-xr-xtests/zfs-tests/tests/functional/mmap/mmap_libaio_001_pos.ksh61
8 files changed, 164 insertions, 2 deletions
diff --git a/tests/runfiles/linux.run b/tests/runfiles/linux.run
index 7c2ca84bf..185293716 100644
--- a/tests/runfiles/linux.run
+++ b/tests/runfiles/linux.run
@@ -572,7 +572,7 @@ tests = ['migration_001_pos', 'migration_002_pos', 'migration_003_pos',
tags = ['functional', 'migration']
[tests/functional/mmap]
-tests = ['mmap_write_001_pos', 'mmap_read_001_pos']
+tests = ['mmap_write_001_pos', 'mmap_read_001_pos', 'mmap_libaio_001_pos']
tags = ['functional', 'mmap']
[tests/functional/mmp]
diff --git a/tests/zfs-tests/cmd/Makefile.am b/tests/zfs-tests/cmd/Makefile.am
index bc19f184c..0673fcbf6 100644
--- a/tests/zfs-tests/cmd/Makefile.am
+++ b/tests/zfs-tests/cmd/Makefile.am
@@ -14,6 +14,7 @@ SUBDIRS = \
mkfiles \
mktree \
mmap_exec \
+ mmap_libaio \
mmapwrite \
nvlist_to_lua \
randfree_file \
diff --git a/tests/zfs-tests/cmd/mmap_libaio/.gitignore b/tests/zfs-tests/cmd/mmap_libaio/.gitignore
new file mode 100644
index 000000000..792c8d340
--- /dev/null
+++ b/tests/zfs-tests/cmd/mmap_libaio/.gitignore
@@ -0,0 +1 @@
+/mmap_libaio
diff --git a/tests/zfs-tests/cmd/mmap_libaio/Makefile.am b/tests/zfs-tests/cmd/mmap_libaio/Makefile.am
new file mode 100644
index 000000000..67d0f0ece
--- /dev/null
+++ b/tests/zfs-tests/cmd/mmap_libaio/Makefile.am
@@ -0,0 +1,9 @@
+include $(top_srcdir)/config/Rules.am
+
+pkgexecdir = $(datadir)/@PACKAGE@/zfs-tests/bin
+
+if WANT_MMAP_LIBAIO
+pkgexec_PROGRAMS = mmap_libaio
+mmap_libaio_SOURCES = mmap_libaio.c
+mmap_libaio_LDADD = $(LIBAIO)
+endif
diff --git a/tests/zfs-tests/cmd/mmap_libaio/mmap_libaio.c b/tests/zfs-tests/cmd/mmap_libaio/mmap_libaio.c
new file mode 100644
index 000000000..21119ebca
--- /dev/null
+++ b/tests/zfs-tests/cmd/mmap_libaio/mmap_libaio.c
@@ -0,0 +1,88 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+
+/*
+ * Copyright 2018 Canonical. All rights reserved.
+ */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <fcntl.h>
+#include <sys/mman.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <libaio.h>
+#include <err.h>
+
+io_context_t io_ctx;
+
+static void
+do_sync_io(struct iocb *iocb)
+{
+ struct io_event event;
+ struct iocb *iocbs[] = { iocb };
+ struct timespec ts = { 30, 0 };
+
+ if (io_submit(io_ctx, 1, iocbs) != 1)
+ err(1, "io_submit failed");
+
+ if (io_getevents(io_ctx, 0, 1, &event, &ts) != 1)
+ err(1, "io_getevents failed");
+}
+
+int
+main(int argc, char **argv)
+{
+ char *buf;
+ int page_size = getpagesize();
+ int buf_size = strtol(argv[2], NULL, 0);
+ int rwfd;
+ struct iocb iocb;
+
+ if (io_queue_init(1024, &io_ctx))
+ err(1, "io_queue_init failed");
+
+ rwfd = open(argv[1], O_RDWR | O_CREAT, S_IRUSR | S_IWUSR);
+ if (rwfd < 0)
+ err(1, "open failed");
+
+ if (ftruncate(rwfd, buf_size) < 0)
+ err(1, "ftruncate failed");
+
+ buf = mmap(0, page_size, PROT_READ | PROT_WRITE, MAP_SHARED, rwfd, 0);
+ if (buf == MAP_FAILED)
+ err(1, "mmap failed");
+
+ (void) io_prep_pwrite(&iocb, rwfd, buf, buf_size, 0);
+ do_sync_io(&iocb);
+
+ (void) io_prep_pread(&iocb, rwfd, buf, buf_size, 0);
+ do_sync_io(&iocb);
+
+ if (close(rwfd))
+ err(1, "close failed");
+
+ if (io_queue_release(io_ctx) != 0)
+ err(1, "io_queue_release failed");
+
+ return (0);
+}
diff --git a/tests/zfs-tests/include/commands.cfg b/tests/zfs-tests/include/commands.cfg
index 64d6ad5d7..2a6c3b13d 100644
--- a/tests/zfs-tests/include/commands.cfg
+++ b/tests/zfs-tests/include/commands.cfg
@@ -164,6 +164,7 @@ export ZFSTEST_FILES='chg_usr_exec
mkfiles
mktree
mmap_exec
+ mmap_libaio
mmapwrite
nvlist_to_lua
randfree_file
diff --git a/tests/zfs-tests/tests/functional/mmap/Makefile.am b/tests/zfs-tests/tests/functional/mmap/Makefile.am
index cb444ec37..4e1db6041 100644
--- a/tests/zfs-tests/tests/functional/mmap/Makefile.am
+++ b/tests/zfs-tests/tests/functional/mmap/Makefile.am
@@ -4,4 +4,5 @@ dist_pkgdata_SCRIPTS = \
cleanup.ksh \
mmap.cfg \
mmap_read_001_pos.ksh \
- mmap_write_001_pos.ksh
+ mmap_write_001_pos.ksh \
+ mmap_libaio_001_pos.ksh
diff --git a/tests/zfs-tests/tests/functional/mmap/mmap_libaio_001_pos.ksh b/tests/zfs-tests/tests/functional/mmap/mmap_libaio_001_pos.ksh
new file mode 100755
index 000000000..36a7e76f9
--- /dev/null
+++ b/tests/zfs-tests/tests/functional/mmap/mmap_libaio_001_pos.ksh
@@ -0,0 +1,61 @@
+#!/bin/ksh -p
+#
+# CDDL HEADER START
+#
+# The contents of this file are subject to the terms of the
+# Common Development and Distribution License (the "License").
+# You may not use this file except in compliance with the License.
+#
+# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+# or http://www.opensolaris.org/os/licensing.
+# See the License for the specific language governing permissions
+# and limitations under the License.
+#
+# When distributing Covered Code, include this CDDL HEADER in each
+# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+# If applicable, add the following below this CDDL HEADER, with the
+# fields enclosed by brackets "[]" replaced with your own identifying
+# information: Portions Copyright [yyyy] [name of copyright owner]
+#
+# CDDL HEADER END
+#
+
+#
+# Copyright 2018 Canonical. All rights reserved.
+#
+
+. $STF_SUITE/include/libtest.shlib
+. $STF_SUITE/tests/functional/mmap/mmap.cfg
+
+#
+# DESCRIPTION:
+# Verify libaio functions correctly with mmap()'d files.
+#
+# STRATEGY:
+# 1. Call mmap_libaio binary
+# 2. Verify the file exists and is the expected size
+# 3. Verify the filesystem is intact and not hung in any way
+#
+
+verify_runnable "global"
+
+log_assert "verify mmap'd pages work with libaio"
+
+# mmap_libaio is built when the libaio-devel package is installed.
+if ! which mmap_libaio; then
+ log_unsupported "This test requires mmap_libaio."
+fi
+
+log_must chmod 777 $TESTDIR
+
+for size in 512 4096 8192; do
+ log_mustnot stat $TESTDIR/test-libaio-file
+ log_must mmap_libaio $TESTDIR/test-libaio-file $size
+ log_must verify_eq $(stat --format=%s $TESTDIR/test-libaio-file) $size
+ log_must rm $TESTDIR/test-libaio-file
+done
+
+typeset dir=$(get_device_dir $DISKS)
+verify_filesys "$TESTPOOL" "$TESTPOOL/$TESTFS" "$dir"
+
+log_pass "mmap'd pages work with libaio"